osgDB::MatrixSerializer< C > Class Template Reference

`#include <Serializer>`

Inheritance diagram for osgDB::MatrixSerializer< C >:

## Public Types

typedef TemplateSerializer< osg::Matrix > | ParentType
typedef const osg::Matrix &(C::* | Getter) () const
typedef void(C::* | Setter) (const osg::Matrix &)
Public Types inherited from osgDB::BaseSerializer

enum

Type {
RW_UNDEFINED = 0 , RW_USER , RW_OBJECT , RW_IMAGE ,
RW_LIST , RW_BOOL , RW_CHAR , RW_UCHAR ,
RW_SHORT , RW_USHORT , RW_INT , RW_UINT ,
RW_FLOAT , RW_DOUBLE , RW_VEC2F , RW_VEC2D ,
RW_VEC3F , RW_VEC3D , RW_VEC4F , RW_VEC4D ,
RW_QUAT , RW_PLANE , RW_MATRIXF , RW_MATRIXD ,
RW_MATRIX , RW_GLENUM , RW_STRING , RW_ENUM ,
RW_VEC2B , RW_VEC2UB , RW_VEC2S , RW_VEC2US ,
RW_VEC2I , RW_VEC2UI , RW_VEC3B , RW_VEC3UB ,
RW_VEC3S , RW_VEC3US , RW_VEC3I , RW_VEC3UI ,
RW_VEC4B , RW_VEC4UB , RW_VEC4S , RW_VEC4US ,
RW_VEC4I , RW_VEC4UI , RW_BOUNDINGBOXF , RW_BOUNDINGBOXD ,
RW_BOUNDINGSPHEREF , RW_BOUNDINGSPHERED , RW_VECTOR , RW_MAP
}

enum | Usage { READ_WRITE_PROPERTY = 1 , GET_PROPERTY = 2 , SET_PROPERTY = 4 , GET_SET_PROPERTY = GET_PROPERTY | SET_PROPERTY }

## Public Member Functions

| MatrixSerializer (const char *name, const osg::Matrix &def, Getter gf, Setter sf)
virtual bool | read (InputStream &is, osg::Object &obj)
virtual bool | write (OutputStream &os, const osg::Object &obj)
Public Member Functions inherited from osgDB::TemplateSerializer< osg::Matrix >
| TemplateSerializer (const char *name, osg::Matrix def)
virtual const std::string & | getName () const
Public Member Functions inherited from osgDB::BaseSerializer
| BaseSerializer (int usage)
virtual bool | set (osg::Object &, void *)
virtual bool | get (const osg::Object &, void *)
virtual IntLookup * | getIntLookup ()
void | setUsage (int usage)
int | getUsage () const
void | setUsage (bool hasGetter, bool hasSetter)
bool | supportsReadWrite () const
bool | supportsGetSet () const
bool | supportsGet () const
bool | supportsSet () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Public Attributes

Getter | _getter
Setter | _setter

## Protected Member Functions

void | readMatrixImplementation (InputStream &is, osg::Matrix &matrix)
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osgDB::TemplateSerializer< osg::Matrix >
std::string | _name
osg::Matrix | _defaultValue
Protected Attributes inherited from osgDB::BaseSerializer
int | _firstVersion
int | _lastVersion
int | _usage
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Member Typedef Documentation

## Getter

template<typename C>

typedef const osg::Matrix &(C::* osgDB::MatrixSerializer< C >::Getter) () const

## ParentType

template<typename C>

typedef TemplateSerializer<osg::Matrix> osgDB::MatrixSerializer< C >::ParentType

## Setter

template<typename C>

typedef void(C::* osgDB::MatrixSerializer< C >::Setter) (const osg::Matrix &)

## Constructor & Destructor Documentation

## MatrixSerializer()

template<typename C>

osgDB::MatrixSerializer< C >::MatrixSerializer | ( | const char * | name,
|  | const osg::Matrix & | def,
|  | Getter | gf,
|  | Setter | sf )

inline

References _getter, _setter, and osgDB::BaseSerializer::setUsage().

## Member Function Documentation

## read()

template<typename C>

virtual bool osgDB::MatrixSerializer< C >::read | ( | InputStream & | is,
|  | osg::Object & | obj )

inline virtual

Implements osgDB::TemplateSerializer< osg::Matrix >.

References osgDB::TemplateSerializer< osg::Matrix >::_name, _setter, osgDB::InputStream::isBinary(), osgDB::InputStream::matchString(), OBJECT_CAST, and readMatrixImplementation().

## readMatrixImplementation()

template<typename C>

void osgDB::MatrixSerializer< C >::readMatrixImplementation | ( | InputStream & | is,
|  | osg::Matrix & | matrix )

inline protected

Referenced by read().

## write()

template<typename C>

virtual bool osgDB::MatrixSerializer< C >::write | ( | OutputStream & | os,
|  | const osg::Object & | obj )

inline virtual

Implements osgDB::TemplateSerializer< osg::Matrix >.

References osgDB::TemplateSerializer< osg::Matrix >::_defaultValue, _getter, osgDB::TemplateSerializer< osg::Matrix >::_name, osgDB::OutputStream::isBinary(), OBJECT_CAST, and osgDB::OutputStream::PROPERTY.

## Member Data Documentation

## _getter

template<typename C>

Getter osgDB::MatrixSerializer< C >::_getter

Referenced by MatrixSerializer(), and write().

## _setter

template<typename C>

Setter osgDB::MatrixSerializer< C >::_setter

Referenced by MatrixSerializer(), and read().

The documentation for this class was generated from the following file:

- Serializer